// SimpleScopeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleScope.h"
#include "SimpleScopeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT ReadLoopRoutine(void* param);

#define XSIZE		256 
#define CLK_FREQ	48
#define COLX		10

#if !defined(XSIZE) || XSIZE > 512
#error "XSIZE uncorrect value"
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleScopeDlg dialog

CSimpleScopeDlg::CSimpleScopeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleScopeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimpleScopeDlg)
	m_NumPoints = _T("");
	m_freq = _T("");
	m_scale = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSimpleScopeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimpleScopeDlg)
	DDX_Control(pDX, IDC_HOLST, m_holst);
	DDX_Text(pDX, IDC_NUMPOINTS, m_NumPoints);
	DDX_Text(pDX, IDC_FREQ, m_freq);
	DDX_Text(pDX, IDC_SCALE, m_scale);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSimpleScopeDlg, CDialog)
	//{{AFX_MSG_MAP(CSimpleScopeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnStartLoop)
	ON_BN_CLICKED(IDC_BUTTON3, OnStopLoop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleScopeDlg message handlers

BOOL CSimpleScopeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimpleScopeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleScopeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleScopeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSimpleScopeDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here

	int status = WUSB_Open();
	if(status == WUSB_ERROR)
	{		
		MessageBox("ERROR! Can`t open WodmanUSB device", "Info", MB_ICONERROR);		
	}
	else
	{
		MessageBox("Open OK", "Info", MB_ICONINFORMATION);		
	}	
	
}

void CSimpleScopeDlg::OnStartLoop() 
{
	// TODO: Add your control notification handler code here
	Terminate = false;	
	PrepareDraw();
	AfxBeginThread(ReadLoopRoutine, this);		
}


//****************************************************************************
UINT ReadLoopRoutine(void* param)
{
	CSimpleScopeDlg* dlg = (CSimpleScopeDlg*)param;
	
	WUSB_SetupPortB(SYNC_MODE_INTERNAL_CLK_48MHZ);	 	
	char buf[65024]; 

	unsigned int dwRead;
	int status;

	while(!dlg->Terminate)
	{
		status = WUSB_ReadPortB(buf, sizeof(buf), &dwRead);
		if(status == WUSB_ERROR)
		{
			MessageBox(NULL, "Read Error!", "", MB_ICONERROR);
			break;
		} 
		else if(status == WUSB_TIMEOUT)
		{
			MessageBox(NULL, "TIMEOUT", "", MB_ICONERROR);
			break;
		}			
		
		dlg->DrawGraph(buf);		
	}	

	return 0;
}

//****************************************************************************
void CSimpleScopeDlg::OnStopLoop() 
{
	// TODO: Add your control notification handler code here
	Terminate = true;
	ReleaseDraw();
}

//****************************************************************************
void CSimpleScopeDlg::PrepareDraw()
{
	de.pDC = GetDC();

	this->m_holst.GetWindowRect(de.cr);
	ScreenToClient(&de.cr);

	de.BlackPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	de.SilverPen.CreatePen(PS_SOLID,1,RGB(235,235,235));
	

	double scale = ((double)XSIZE/(CLK_FREQ*COLX))*1000; //[ns]

	this->m_freq.Format("%d", CLK_FREQ);
	this->m_NumPoints.Format("%d", XSIZE);
	this->m_scale.Format("%f", scale);	

	UpdateData(false);
	
}

//****************************************************************************
void CSimpleScopeDlg::ReleaseDraw()
{
	ReleaseDC(de.pDC);
	de.BlackPen.DeleteObject();
	de.SilverPen.DeleteObject();
}


//****************************************************************************
void CSimpleScopeDlg::DrawGraph(char *buf)
{	
	for(int i = 0; i < XSIZE; i++)
	{			
		buf[i] = ((buf[i] >> 7) & 0x01);	
	}
	
	de.pDC->SelectStockObject(NULL_PEN);
	de.pDC->Rectangle(&de.cr);
	
	

	int H = de.cr.Height();  // 
	int W = de.cr.Width();   // 


	int dx = de.cr.left;		 //  x
	int dy = de.cr.top + H - 10; //  y



	//**************   X *****************
	de.pDC->SelectObject(&de.SilverPen);	

	int ColX = COLX;
	for (int e = 1; e <= ColX; e++)
	{
		de.pDC->MoveTo(dx-2+e*(W/ColX), dy + 10);	
		de.pDC->LineTo(dx-2+e*(W/ColX), dy - H + 10);
	}

	//**************   Y *****************
	int ColY = H/(W/ColX);
	for (e = 1; e <= ColY; e++)
	{
		de.pDC->MoveTo(dx,	dy+10-e*(H/ColY));		
		de.pDC->LineTo(dx+W,dy+10-e*(H/ColY));		
	}



	double xKoef = ((double)W)/((double)XSIZE);
	double yKoef = H - 50;


	de.pDC->SelectObject(&de.BlackPen);

	int x1 = dx;
	int y1 = dy;
	de.pDC->MoveTo(x1,y1);
	

	for (int r = 0; r < XSIZE; r++)
	{
		x1 = r*xKoef + dx;
		y1 = dy - (buf[r])*yKoef;							
		de.pDC->LineTo(x1,y1);			

	}
}